--[[################################################################################    
    # File      : /hook/lua/ui/dialogs/ConsoleCommands.lua                         #    
    # Author    : Manimal                                                          #    
    # Version   : 25 septembre 2008                                                #    
    # Revision  : 09 novembre 2008                                                 #    
    #                                                                              #    
    # Summary   : Console that brings some new features                            #    
    # Copyright :  2005 Gas Powered Games + Manimal. All rights reserved.         #    
    ################################################################################]]--


#  FAIRE :
# =========
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# AJOUTER 1 CHAMP "type de commande" (UI, AI, SIM, etc)
# TABLIR 1 LISTE EXTERNE de RGLES propres aux Commandes Perso + 1 LISTE INTERNE SPARE pour les autres
# ex: commande = "..." , descrA = "...", conditions = {...}, actions = {...}, info_aide = "..." , (...?)
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# NOTES :
#  la commande Ignore conduira  la cration ou  la Mise  Jour d'1 IgnoreList.
#  la commande UnIgnore conduira  la Mise  Jour d'IgnoreList (si NickName existe).
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


local Game = import('/lua/game.lua')
local MyModPath = Game.MyModPath


################################################################################
# IMPORTS

local utils = import( '/lua/system/utils.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local console = import( MyModPath.. '/hook/lua/ui/dialogs/console.lua' )
local ConsolePlus = import( MyModPath..'/hook/lua/ui/dialogs/ConsolePlus.lua' )

################################################################################
# VARIABLES

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
recupData = { }  # DUMP TEMP Console  # INFO SENSIBLE, NE PAS TOUCHER !
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
CommandsList = {}


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# mesCommandesConsole = { commande = "...", descrA = "...", info_aide = "...", }
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#  FAIRE ? :
#    {
#		commande = "NewCommand",
#		descrA = "This is a New command.",
#		descrB = "It does this and that.",
#		actions = { doThis, doThat }, # Nom de la fonction.
#		conditions = { IsOkForThat }, # AUCUNE !
#		info_aide = "Idea for New Command stuff", # AUCUNE !
#    },
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

mesCommandesConsole = {
    {
		commande = "Info",
		descrA = LOC( "<LOC mCC_Info_desc>Displays some Text on Console Display. e.g. Info Hello Halcyon!" ),
		descrB = "",    # NEANT
		info_aide = "", # AUCUNE !
    },
    {
		commande = "Help",
		descrA = LOC( "<LOC mCC_Help_desc>Displays Commands List." ),
		descrB = "",    # NEANT
		info_aide = "", # AUCUNE !
    },
    {
		commande = "CON_ClearDisplay",
		descrA = LOC( "<LOC mCC_ClrDisp_desc>Clear Console Display Window." ),
		descrB = "",
		info_aide = "",
    },
    {
		commande = "NoShake",
		descrA = LOC( "<LOC mCC_NoShake_desc>Toggles Camera Shaking ON or OFF." ),
		descrB = "",
		info_aide = LOC( "<LOC mCC_toggle_info>Enter again this command to revert its effect." ),
    },
    {
		commande = "Pref_GameSpeed",
		descrA = LOC( "<LOC mCC_GameSpeed_desc>Toggles between prefered and default game speed at game load time." ),
		descrB = "",
		info_aide = LOC( "<LOC mCC_toggle_info>Enter again this command to revert its effect." ),
    },
    #{
	#	commande = "Chat_Ignore",
	#	descrA = LOC( "<LOC mCC_ChatIgnore_desc>New CHAT command for ignoring some players in lobby." ),
	#	descrB = "",
	#	info_aide = LOC( "<LOC mCC_ChatIgnore_info>e.g. Ignore nickname." ),
    #},
    #{
	#	commande = "Chat_UnIgnore",
	#	descrA = LOC( "<LOC mCC_ChatUnign_desc>New CHAT command for unignoring some players in lobby." ),
	#	descrB = "",
	#	info_aide = LOC( "<LOC mCC_ChatUnign_info>e.g. UnIgnore nickname." ),
    #},
}



################################################################################
# FONCTIONS


--[[################################################################################
# Controler et COMPARER la Commande Saisie avec la Liste des Commandes Perso.
# matches DOIT tre une liste de chaines texte, text = chaine de 1  n car.
# Renvoie les commandes correspondantes commenant par la chaine text qui sont
# ensuite AJOUTES  la liste des commandes dj trouves par ConTextMatches.
# NE RENVOIE AUCUNE ERREUR ! ( soit ajoute du texte, soit ne fait rien )
################################################################################]]--

function myConTextMatches( matches, text )
	if matches and not (matches == nil) then
		if text and not (text == nil) and ( type(text)=='string' ) then
			local tLong =  string.len(text)
			if (tLong > 0) then
				local cmdFound = false
				for _, cmdStr in mesCommandesConsole do
					if ( tLong <= string.len(cmdStr.commande) ) then 
						local subCmdStr = string.sub( cmdStr.commande, 1, tLong )
						if ( string.lower(text) == string.lower(subCmdStr) ) then
							table.insert( matches, cmdStr.commande )
						end
					end
				end
			end
		end
		if table.getn( matches ) > 0 then
			matches = ConsolePlus.TriTable( matches, '<' )  # TRIER LA LISTE avec TriTable( tabl, ordreTri, clefTri )
		end
	end

	return matches
end


################################################################################
# Rcupre la Liste des Commandes de la Console et leur Descrition.
################################################################################

function GetCommandsListFromConsole()
	local cmnde = 'CON_ListCommands'
	local cmdLine = { ligne = cmnde, cmnde = cmnde, param = false, muteCon = true, aide = '', substLigne = '' }
	ConExecute( cmnde )
end


--[[################################################################################
# Compilation des Commandes Originales de la Console et des Commandes Perso
# avec leur description et leur aide en ligne (info-aide).
# Ncessite la Liste obtenue par GetCommandsListFromConsole()
################################################################################ ]]--

function CreateDetailedConsoleCommandsList()	
	local cmdFound = false
	local commande = ""
	local descrA = ""
	local descrB = ""
	local info_aide = ""
	
	if recupData and not(recupData == nil) then # DEVRAIT TRE TABLE TRIE !
		for index, ligne in recupData do                           # Sparer les Commandes et leur description.  
			if  ( type(ligne) == 'string' ) then                   # de Type Chaine de Car.
				longLn = string.len(ligne)
				local iDeb = 0      # index dbut du 1er mot
				local iFin = 0      # index   fin du 1er mot
				
				for i = 1, longLn do
					if not( string.sub(ligne, i, i) == " " ) then   # IGNORER LE PREMIER BLOC ESPACE
						iDeb = i                                    # mmo index dbut du 1er mot
						iFin = string.find( ligne, " ", iDeb )      # mmo index+1 fin du 1er mot
						if not (iFin == nil) then
							commande = string.sub( ligne, iDeb, (iFin - 1) )
							cmdFound = true
							break
						end
					end
				end
				
				for j = iFin, longLn do
					if not( string.sub(ligne, j, j) == " " ) then   # IGNORER LE SECOND BLOC ESPACE
						descrA = ""
						descrB = ""
						
						local nbCar = 60
						local debDa = j
						local longDesc = longLn - debDa
						local diffDesc = nbCar - longDesc
						
						if ( diffDesc >= 0) then                       # Descripteur plus petit que cran console
							descrA = string.sub( ligne, debDa, longLn )
						else                                           # Descripteur plus grand que cran console
							local finDa = j + nbCar
							while not( string.sub( ligne, finDa, finDa ) == " " ) do
								finDa = finDa - 1
							end
							
							descrA = string.sub( ligne, debDa, (finDa - 1) )    # Pas de coupure de mot ni espace final
							descrB = string.sub( ligne, (finDa + 1), longLn )
						end
						
						break
					end
				end
				
				--table.insert ( cmdList, { commande = commande, descrA = descrA, descrB = descrB, actions = {}, conditions = {}, info_aide = {}  } )
				table.insert ( CommandsList, { commande = commande, descrA = descrA, descrB = descrB, info_aide = ""  } )
			else # SHOULD NEVER OCCUR.
				WARN('MANIMAL DEBUG: ConsoleCommands.lua  -> Error in CreateDetailedConsoleCommandsList: Unexpected Data Type in table recupText at indice '..tostring(index)..', skipping it...')
			end
		end
	else
		WARN("MANIMAL DEBUG: ConsoleCommands.lua  -> Error in CreateDetailedConsoleCommandsList: FAILURE, Got No Data to work with !")
	end
	for _, maCommande in mesCommandesConsole do
		table.insert ( CommandsList, maCommande )
	end
	if cmdFound then
		CommandsList = ConsolePlus.TriTableComplexe( CommandsList , '<', 'commande' )  # TRIER LA LISTE DES ITEMS avec TriTable( tabl, ordreTri, clefTri )
	end
end


################################################################################
# Renvoie le Nombre Total des Commandes de la Console.
################################################################################

function GetConsoleCommandsListCount()
    local nbrTotalCommandes = table.getn( CommandsList ) or 0
    return nbrTotalCommandes
end


################################################################################
# AFFICHAGE de la Liste des Commandes recréé par GetDetailedConsoleCommandsList().
################################################################################

function ShowDetailedConsoleCommandsList()
	if CommandsList and not(CommandsList == nil) and ( type(CommandsList) == 'table' ) and (table.getn(CommandsList) > 0) then
		
		local cmnde = 'con_echo'
		
		# Affichage ligne <<titre>>
		local param = ' '..LOC('<LOC _cmd_list_header>--- COMPLETE LIST OF COMMANDS ---')
		local ligne = cmnde .. param
		cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = false, aide = '', substLigne = '' }
		ConExecute( ligne )            # EXECUTION DIRECTE de la Commandes Console
		
		for _, cmd in CommandsList do
			# Affichage ligne <<commande>>
			local param = ' '..' -> ' .. cmd.commande .. ' :'
			local ligne = cmnde .. param
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = false, aide = '', substLigne = '' }
			ConExecute( ligne )            # EXECUTION DIRECTE de la Commandes Console
			
			# Affichage ligne <<descrA>>
			local param = ' '..'  ' .. cmd.descrA
			local ligne = cmnde .. param
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = false, aide = '', substLigne = '' }
			ConExecute( ligne )            # EXECUTION DIRECTE de la Commandes Console
			
			# Affichage ligne <<descrB>>
			if not( cmd.descrB == "" ) then
				local param = ' '..'  ' .. cmd.descrB
				local ligne = cmnde .. param
				cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = false, aide = '', substLigne = '' }
				ConExecute( ligne )            # EXECUTION DIRECTE de la Commandes Console
			end
		end
	else
		WARN("MANIMAL DEBUG: ConsoleCommands.lua  -> Error in ShowDetailedConsoleCommandsList: FAILURE, Got No Data to work with !")
	end
end



################################################################################
# Rcupre le Batch de Commandes Spcifi
################################################################################

function GetCommandsBatch( batchFileName )
end



################################################################################

