--[[################################################################################    
    # File      : /hook/lua/ui/dialogs/ConsolePlus.lua                             #    
    # Author    : Manimal                                                          #    
    # Version   : 25 septembre 2008                                                #    
    # Revision  : 09 novembre 2008                                                 #    
    #                                                                              #    
    # Summary   : Console that brings some new features                            #    
    # Copyright :  2005 Gas Powered Games + Manimal. All rights reserved.         #    
    ################################################################################]]--

# NOTES :
# =======
# 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# TABLIR 1 LISTE EXTERNE de RGLES propres aux Commandes Perso
# TABLIR 1 LISTE INTERNE pour les autres Commandes
# ex: commande = '...', descrA = "...", descrB = "...", conditions = {...}, actions = {...}
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# AJOUTER INFO DBIT KBPS ENTRANT ET SORTANT DU JEU !!! :S
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


local Game = import('/lua/game.lua')
local MyModPath = Game.MyModPath



################################################################################
# IMPORTS

local Prefs = import('/lua/user/prefs.lua')
local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Window = import('/lua/maui/window.lua').Window
local ItemList = import('/lua/maui/itemlist.lua').ItemList
local Tooltip = import('/lua/ui/game/tooltip.lua')
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local GameMain = import( MyModPath.. '/hook/lua/ui/game/gamemain.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local console = import( MyModPath.. '/hook/lua/ui/dialogs/console.lua' )
local ConsoleCommands = import( MyModPath..'/hook/lua/ui/dialogs/ConsoleCommands.lua' )



################################################################################
# VARIABLES

cameraShake_OFF   = 0              
prec_camShakeMult = Prefs.GetFromCurrentProfile('cam_ShakeMult') or 0  # INIT = cam_ShakeMult PRCDENT STOCK DANS PROFIL ou bien Mode NoShake
nouv_camShakeMult = 0
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
cmdLine     = { ligne = '', cmnde = '', param = 0 or false, muteCon = false, aide = '' , substLigne = '' }
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


################################################################################
# FONCTIONS


--[[################################################################################
# COMPARAISON ALPHABETIQUE DE CHAINES - CHARWISE STRING COMPARATOR
# Rsultat indpendant de la longueur des CHAINES contrairement  "s1 < s2".
# Results are NOT String length dependent contrarily to "s1 < s2".
# RENVOIE chnA,chnB SI ERREUR OU false SI LONG NULLE; SINON '<', '=', '>'.
# RETURNS IF ERROR chnA,chnB ELSE IF LENGTH ZERO false; ELSE '<', '=', '>'.
################################################################################ ]]--

function ComparAlphabChaines( chnA, chnB )
	if not(chnA) or (chnA == nil) or not(type(chnA) == 'string') then
		WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in ComparAlphabChaines: a string was expected (chnA) ! ' )
		return chnA, chnB
	end
	--if not(chnB) or (chnB == nil) or not(type(chnB) == 'string') then
	if not(chnB) or (chnB == nil) or not(type(chnB) == 'string') then
		WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in ComparAlphabChaines: a string was expected (chnB) ! ' )
		return chnA, chnB
	end
	
	local resultat = '?'
	local longChA = string.len( chnA )
	local longChB = string.len( chnB )
	
	if ( longChA > 0 ) and ( longChB > 0 ) then
		if ( longChA > longChB ) then
			laPlusCourte = longChB
		else
			laPlusCourte = longChA
		end
		
		chnA = string.lower(chnA)
		chnB = string.lower(chnB)
		
		if ( string.sub(chnA, 1, laPlusCourte) == string.sub(chnB, 1, laPlusCourte) ) then
			return '=' --resultat = '='
		end
		
		for i = 1, laPlusCourte do
			if ( string.sub(chnA, i, i) > string.sub(chnB, i, i) ) then
				resultat = '>'
				break
			elseif ( string.sub(chnA, i, i) < string.sub(chnB, i, i) ) then
				resultat = '<'
				break
			end
		end
	end
	
	return resultat
end


################################################################################
# FONCTION DE TRI de TABLE COMPLEXES - Complex Table Sorting utility
################################################################################

function TriTableComplexe( tabl, ordreTri, clefTri )
	if tabl and not(tabl == nil) and (type(tabl) == 'table') then
		if table.getn( tabl ) > 0 then               # TRIER 1 OU PLUS LMENT(s)
			local nbElmntTabl = table.getn( tabl )
			local tableTriee = table.deepcopy( tabl ) # Table de Travail, pour prserver tabl originale
			local nbrPermutations = 0
			
			if not(type(clefTri) == 'string') then
				WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in TriTableComplexe: CLEF de TRI INVALIDE  ! ' )
				return tabl
			end
			
			repeat
				nbrPermutations = 0
				for i = 1, nbElmntTabl do
					local j = i + 1
					if ( j <= nbElmntTabl ) then
						if type( tableTriee[i][clefTri]) == 'string' then
							if ( ordreTri == '<' ) or  ( ordreTri == '>' )then
								if ( ComparAlphabChaines( tableTriee[j][clefTri], tableTriee[i][clefTri] ) == ordreTri ) then
									local element = tableTriee[i]
									tableTriee[i] = tableTriee[j]
									tableTriee[j] = element
									nbrPermutations = nbrPermutations + 1    # IL RESTE ENCORE LMENT  TRIER !
								end
							end
						else  # NI CHAINE NI TABLE !
							break
						end
					end
				end
			until ( nbrPermutations == 0 )
			
			return tableTriee
		else
			WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in TriTableComplexe: RIEN  TRIER  ! ' )
		end
	else
		WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in TriTableComplexe: a table was expected  ! ' )
	end
	
	return tabl
end


################################################################################
# FONCTION DE TRI de TABLE de CHAINES - Table of Strings Sorting utility
################################################################################

function TriTable( tabl, ordreTri, clefTri )
	if tabl and not(tabl == nil) and (type(tabl) == 'table') then
		if table.getn( tabl ) == 1 then               #  QUOI SERVIRAIT DE TRIER 1 SEUL LMENT ? :P
			return tabl
		elseif table.getn( tabl ) > 1 then               # TRIER 2 OU PLUS LMENT(s)
			local nbElmntTabl = table.getn( tabl )
			local tableTriee = table.deepcopy( tabl ) # Table de Travail, pour prserver tabl originale
			local nbrPermutations = 0
			
			repeat
				nbrPermutations = 0
				for i = 1, nbElmntTabl do
					local j = i + 1
					if ( j <= nbElmntTabl ) then
						if type( tableTriee[i]) == 'table' then
							if clefTri and not(clefTri == nil) then
								# exemple : tableTriee[i][clefTri] = "AddBeam"
								#LOG( 'RCURSION SOUS-TABLE AVEC CLEF ...' )
								return TriTableComplexe( tableTriee, ordreTri, clefTri )  # RCURSION !!!
							else
								#LOG( 'RCURSION SOUS-TABLE SANS CLEF ...' )
								TriTable( tableTriee[i], ordreTri, clefTri )  # RCURSION !!!
							end
						elseif type( tableTriee[i]) == 'string' then
							if ( ordreTri == '<' ) or  ( ordreTri == '>' )then
								if ( ComparAlphabChaines( tableTriee[j], tableTriee[i] ) == ordreTri ) then
									local element = tableTriee[i]
									tableTriee[i] = tableTriee[j]
									tableTriee[j] = element
									nbrPermutations = nbrPermutations + 1    # IL RESTE ENCORE LMENT  TRIER !
								end
							end
						else  # NI CHAINE NI TABLE !
							break
						end
					end
				end
			until ( nbrPermutations == 0 )
			
			return tableTriee
		else
			WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in TriTable: RIEN  TRIER  ! ' )
		end
	else
		WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in TriTable: a table was expected  ! ' )
	end
	
	return tabl
end


################################################################################
# Fixer Valeur de cam_ShakeMult de la CONSOLE -  0 = No Shake, n = valeur lue
# Utilis par ToggleCameraShake() - TRAITEMENT <<SILENCIEUX>> !!!
################################################################################

function SetCameraShakeMult( camShakeMult, muteCon )
	if camShakeMult then
		if (type(camShakeMult) == 'number') then
			nouv_camShakeMult = camShakeMult    # Permet de se passer de la console pour lecture de camShakeMult
			local ligne = string.format('cam_ShakeMult %3.2f', camShakeMult)
			cmdLine = { ligne = ligne, cmnde = 'cam_ShakeMult', param = camShakeMult, muteCon = muteCon, aide = '', substLigne = '' }
			ConExecuteSave( ligne )
		else
			WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in SetCameraShakeMult: Wrong TYPE -> '..type(camShakeMult)..' <-, a number was expected  ! ' )
		end
	end
end

################################################################################
# Rcuprer DERNIER cam_ShakeMult PASS  la CONSOLE - Renvoie 1 NUMBER
# Utilis par ToggleCameraShake() - TRAITEMENT <<SILENCIEUX>> !!!
################################################################################

function GetCameraShakeMult()    # VERSION COURTE donnant tat des 2 variables utlises. 
	local camShakeMult = false
	if not nouv_camShakeMult or (nouv_camShakeMult == nil) or not(type(nouv_camShakeMult) == 'number') then
		WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in GetCameraShakeMult: Failed to get nouv_camShakeMult ! (type = '..type(nouv_camShakeMult)..', valeur = '..repr(nouv_camShakeMult)..')  ')
	else
		camShakeMult = nouv_camShakeMult
	end
	if not cmdLine.param  or  (cmdLine.param == nil)  or  not(type(cmdLine.param) == 'number')     then
		WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in GetCameraShakeMult: Failed to get cmdLine.param ! (type = '..type(cmdLine.param)..', valeur = '..repr(cmdLine.param)..')  ')
	else
		camShakeMult = cmdLine.param
	end
	
	cmdLine = { ligne ='cam_ShakeMult', cmnde = 'cam_ShakeMult', param = camShakeMult, muteCon = true, aide = '', substLigne = '' }
	return camShakeMult      # exemple de valeur attendue 1.000
end



################################################################################
# Fixer Valeur de cam_ShakeMult dans PROFILE
# Utilis par ToggleCameraShake()
################################################################################

function SetCameraShakeMultToCurProfile( camShakeMult )
	if camShakeMult then
		if type(camShakeMult) == 'number' then
			Prefs.SetToCurrentProfile( 'cam_ShakeMult', camShakeMult )
		else
			WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in SetCameraShakeMultToCurProfile: Wrong TYPE -> '..type(camShakeMult)..' <-, a number was expected ! ' )
		end
	end
end

################################################################################
# Rcuperer Valeur de cam_ShakeMult du PROFILE -> Renvoie 1 NUMBER
# Utilis par ToggleCameraShake()
################################################################################

function GetCameraShakeMultFromCurProfile()
	local camShakeMult = false    # Fixer sur FAUX pour gestion Erreur
	local prefCamShake = Prefs.GetFromCurrentProfile('cam_ShakeMult') or 1
	
	if prefCamShake and ( type(prefCamShake)=='number' ) then
		camShakeMult = prefCamShake   #  CONCATENER AVEC tostring(camShakeMult) AVANT COMMANDE CONSOLE !!!
	else
		WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in GetCameraShakeMultFromCurProfile: Wrong TYPE -> '..type(prefCamShake)..' <-, a number was expected ! ' )
	end
	
	return camShakeMult  # exemple de valeur 1.0000
end



################################################################################
# Fixer TAT de No_Shake dans PROFILE ( noShake = true ou false )
# Utilis par ToggleCameraShake()
################################################################################

function SetNoShakeToCurProfile( noShake )
	if noShake then
		if type(noShake) == 'boolean' then
			Prefs.SetToCurrentProfile( 'No_Shake', noShake )
		else
			WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in SetNoShakeToCurProfile: Wrong TYPE -> '..type(noShake)..' <-, a boolean was expected ! ' )
		end
	end
end

################################################################################
# Rcuperer TAT de No_Shake dans PROFILE -> Renvoie 1 BOOLEAN
# Utilis par ToggleCameraShake()
################################################################################

function GetNoShakeFromCurProfile()
	local noShake = false    # Fixer sur FAUX pour gestion Erreur
	local prefNoShake = Prefs.GetFromCurrentProfile('No_Shake') or false
	
	if not(prefNoShake == nil) and ( type(prefNoShake)=='boolean' ) then
		noShake = prefNoShake
	else
		WARN(' MANIMAL DEBUG:  ConsolePlus.lua -> Error in GetNoShakeFromCurProfile: a boolean was expected ! ' )
	end
	
	return noShake  # exemple de valeur true
end



################################################################################
# BASCULER cam_ShakeMult et NoShake avec MISE  JOUR du PROFILE
# TRAITEMENT <<SILENCIEUX>> !!!
################################################################################

function ToggleCameraShake()
	local prof_camShakeMult = GetCameraShakeMultFromCurProfile() or 1 # cam_ShakeMult Prcdent stock dans Profil
	if console.IsFirstRun then
		SetCameraShakeMult( prec_camShakeMult or prof_camShakeMult, true )  # RESTAURER VALEUR de cam_ShakeMult
		GameMain.NoCameraShake = not(GameMain.NoCameraShake)          # RESTAURER TAT CAMERA SHAKE
		console.IsFirstRun = false
	end
	
	local actu_camShakeMult = GetCameraShakeMult()  or 1       # cam_ShakeMult Courant
	if GameMain.NoCameraShake then
		nouv_camShakeMult = prec_camShakeMult                  # Rcuprer cam_ShakeMult PRCDENT (ractiver)
		GameMain.NoCameraShake = false                         # INTERDIRE CAMERA SHAKE
	else
		nouv_camShakeMult = cameraShake_OFF                    # Dsactiver CAMERA SHAKE
		GameMain.NoCameraShake = true                          # AUTORISER CAMERA SHAKE
	end
	prec_camShakeMult = actu_camShakeMult                      # Courant deviendra Prcdent
	SetNoShakeToCurProfile( GameMain.NoCameraShake )           # Enregistrer TAT de NoShake dans Profil Courant
	SetCameraShakeMultToCurProfile( nouv_camShakeMult )        # Nouveau cam_ShakeMult dans Profil Courant
	SetCameraShakeMult( nouv_camShakeMult, true )              # Appliquer Nouveau cam_ShakeMult
end



################################################################################
# Affiche Fentre Aide Spcifique  Console Plus
################################################################################
local fenAide = false

function DisplayConPlusHelpWindow()
    
	if fenAide then return end
	
	local texteAideCP = {
		"<LOC _texteAideCP_01>How to get the complete Console commands list :",
		"",
		"<LOC _texteAideCP_02>- Click on the edit box on the bottom left part.",
		"<LOC _texteAideCP_03>- Enter \"Help\" that will display the complete Console commands list.",
		"",
		"",
		"<LOC _texteAideCB_01>How to Edit a command Batch:",
		"",
		"<LOC _texteAideCB_02>At the very first time you're using this console, the Batch should be empty.",
		"<LOC _texteAideCB_03>Left click on the Console's Edit field at the bottom left part of the Console.",
		"<LOC _texteAideCB_04>Type in the desired command that should pop up in a valid function names list.",
		"<LOC _texteAideCB_05>Then click on one of the 4 buttons below in order to :",
		"<LOC _texteAideCB_06>  [+] Copy + Paste a valid command to the Batch Editor's edit box.",
		"<LOC _texteAideCB_07>  [-] Delete a command from the Batch Editor's command list.",
		"<LOC _texteAideCB_08>  [x] Cancel a Copy + Paste operation that was performed through the [+] button.",
		"<LOC _texteAideCB_09>  [?] Show up the present Help window.",
		"",
		"",
		"<LOC _texteAideCB_10>Possible Operations when the batch already contains some commands:",
		"",
		"<LOC _texteAideCB_11>  1- Press the Up and Down arrow key on the keybord in order to select any line from the Batch.",
		"<LOC _texteAideCB_12>     This line should show up in the edit box that's below the Batch.",
		"<LOC _texteAideCB_13>     Once you get the desired line, click on it in order to alter it.",
		"<LOC _texteAideCB_14>     Then press the Enter key in order to validate your changes.",
		"<LOC _texteAideCB_15>  2- Create a new commands Batch by clicking on the [New] button. (resets it totally)",
		"<LOC _texteAideCB_16>  3- In case of editing error, reload the commands Batch by clicking on the [Load] button.",
		"<LOC _texteAideCB_17>  4- Save the currently displayed commands batch by clicking on the [Save] button.",
		"<LOC _texteAideCB_18>  5- Run the current commands batch by clicking on the [Run] button.",
		"",
		"",
		"<LOC _texteAideMF_01>Manimal thanks you for having chosen his Mod Console Plus.",
	}
	
	
	# FENTRE d'AIDE
	local fenAideW = 600
	local fenAideH = 450
	--local fenAideT = ( 1024 - fenAideW ) / 2
	local fenAideT = 30
	local marge = 5
	local cphFontName = UIUtil.fixedFont
	local cphFontSize = 14
	
    local mainFrame = GetFrame(0)
	local nomFenAide = LOC('<LOC _ConPlusHelpWindow>Console Plus Help')
    local location = { Top = fenAideT, Left = fenAideT, Bottom = fenAideH + fenAideT, Right = fenAideW + fenAideT }
	
    # TAILLE FIXE -> #fenAide = Window( mainFrame, nomFenAide, nil, nil, false, true, false, 'conplus_help_window', location )
    fenAide = Window( mainFrame, nomFenAide, nil, nil, false, false, false, 'conplus_help_window', location )
    fenAide.Depth:Set( mainFrame:GetTopmostDepth() + 1 )
    fenAide:SetMinimumResize( fenAideW, fenAideH )
	
	Tooltip.AddButtonTooltip(fenAide._closeBtn, 'consplus_help_close')
	
    local clientAide = fenAide:GetClientGroup()
	
	# LISTE ITEMS contenant le texte d'aide
	tAideListe = ItemList( clientAide )
	LayoutHelpers.AtLeftTopIn( tAideListe, fenAide )
	tAideListe.Top:Set( function() return clientAide.Top() + 10 end )
	tAideListe.Right:Set( function() return clientAide.Right() - 40 end )
    tAideListe.Left:Set(function() return clientAide.Left() + 10 end)
    tAideListe.Bottom:Set(function() return clientAide.Bottom() - 10 end)
	tAideListe:SetColors(UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor(), UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor())
	tAideListe:SetFont( cphFontName, cphFontSize )

	for i, texteACP in texteAideCP do
		local tACP = LOC( texteACP )
		tAideListe:AddItem( tACP )
		if tAideListe:NeedsScrollBar() then
			UIUtil.CreateVertScrollbarFor( tAideListe )
		end
	end
    
	# FERMETURE FENTRE CONFIG
    fenAide.OnClose = function(self)
		self:Destroy()
		fenAide = false
	end
	
	return fenAide
end



--[[################################################################################
# Analyse et Interprete la Commande Courante Saisie  la CONSOLE.
# Filtre la Console pour permettre de CRER une NOUVELLE COMMANDE.
# Renvoie cmdLine pour traitement spcifique.
# exemple de saisie entre crochets : [cam_ShakeMult 25] (wow shaky ! :P)
# ==============================================================================
# CONVENTIONS :
# =====================
#  ligne = '' => Commande NON VALIDE => FILTRER, informer via AIDE.
#  ligne = 'abc' => Commande: VALIDE INTERNE, ou SI EXTERNE => RENVOYER INTACTE !
#  muteCon = false => NE PAS MODIFIER, 
#  substLigne = '' => AUCUNE Commande de SUBSITUTION, ne rien faire.
#  substLigne = 'abc' =>  Commande de SUBSITUTION, pour crer RACCOURCIS notamment.
# ==============================================================================
################################################################################]]--


function Interpreter( texte )
	cmdLine = { }       # RZ indispensable AVANT MJ !
	local ligne = ''
	local cmnde = ''
	local param = false
	local muteCon = false
	local aide = ''
	local substLigne = ''
	local txtMini = string.lower(texte)
	local cmdMini = ''
	
    if texte and string.len(texte) > 0 then # PAS DE TEST type = string, TEST string.len EST SUPERFLU ???
		
		# EXTERNE  la Console
		cmnde = 'Echo'
		cmdMini = string.lower( cmnde )..' ' # AVEC ESPACE pour permettre vrifier prsence Texte  afficher
		local cLong = string.len( cmdMini )
		if ( string.sub(txtMini, 1, cLong) == cmdMini ) and ( string.len( texte ) > cLong ) then
			param = string.sub( texte, (cLong+1), string.len(texte) )
			muteCon = true
			aide = param
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		elseif ( texte == cmnde ) or ( ( txtMini ..' ') == cmdMini ) then    # test AVEC ESPACE au cas o...
			return cmdLine    # NE RIEN FAIRE, DOIT RESTER <<SILENCIEUX>>
		end
		
		# EXTERNE  la Console
		cmnde = 'Info'
		cmdMini = string.lower( cmnde )..' ' # AVEC ESPACE pour permettre vrifier prsence Texte  afficher
		local cLong = string.len( cmdMini )
		if ( string.sub(txtMini, 1, cLong) == cmdMini ) and ( string.len( texte ) > cLong ) then
			param = string.sub( texte, (cLong+1), string.len(texte) )
			muteCon = true
			substLigne = string.format( 'con_echo %s', param )
			cmdLine = { ligne = cmnde, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		elseif ( texte == cmnde ) or ( ( txtMini ..' ') == cmdMini ) then    # test AVEC ESPACE au cas o...
			aide = LOC( '<LOC Info_mis_Txt>Text is missing ! example of use: Info Hello Halcyon!' )
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		end
		
		# INTERCEPTER "CON_ListCommands" ? DOIT SE COMPORTER COMME MA COMMANDE "Help" ???
		
		# EXTERNE  la Console
		#  faire: prvoir traitement pour commandes genre "Help AI", "Help CON"
		cmnde = 'Help'
		cmdMini = string.lower( cmnde )
		if ( txtMini == cmdMini ) then
			ConsoleCommands.ShowDetailedConsoleCommandsList()
			aide = LOC( '<LOC _done>done !' )
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		end
		
		# EXTERNE  la Console
		cmnde = 'CON_ClearDisplay'
		cmdMini = string.lower( cmnde )
		if ( txtMini == cmdMini ) then
			muteCon = true
			cmdLine = { ligne = cmnde, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		end
		
		# INTERNE  la Console
		cmnde = 'cam_ShakeMult'
		cmdMini = string.lower( cmnde )..' ' # AVEC ESPACE pour permettre vrifier Tentatives de Modif de cam_ShakeMult
		local cLong = string.len( cmdMini )
		if ( string.sub(txtMini, 1, cLong) == cmdMini ) then
			param = tonumber(  string.sub( texte, (cLong+1), string.len(texte) )  )
			if GameMain.NoCameraShake then
				aide = LOCF( '<LOC cmnde_aide_01>Command \"%s\" is Locked !  Enter \"NoShake\" if needed.', cmnde )
				cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
				return cmdLine
			else  # GRER LES CHANGEMENTS DE cam_ShakeMult !
				if (param == 0) then  # Retour en mode NoShake suite  commande 'cam_ShakeMult 0' !!!
					ToggleCameraShake()
				elseif (param > 0) then
					SetCameraShakeMultToCurProfile( param ) # MMORISER LES CHANGEMENTS DE cam_ShakeMult !
					SetCameraShakeMult( param, false )    # false pour mode non silencieux
				end
				aide = LOCF('<LOC cmnde_aide_02>New Value -> float cam_ShakeMult == %3.2f', param )
				cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
				return cmdLine
			end
		end
		
		# EXTERNE  la Console
		cmnde = 'NoShake'
		cmdMini = string.lower( cmnde )
		local cLong = string.len( cmnde )  # NoShake suivi d'autre chose est considr comme non valide
		if ( string.sub(txtMini, 1, cLong) == cmdMini ) and ( string.len( texte ) > cLong ) then
			param = string.sub( texte, (cLong+1), string.len(texte) )
			aide = LOCF('<LOC cmnde_aide_03>Unknown console command \"%s\"', texte)
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		elseif ( txtMini == cmdMini ) then
			ToggleCameraShake()
			if GameMain.NoCameraShake then
				param = 0
				aide = LOCF('<LOC cmnde_aide_04>%s is Enabled !', cmnde) .. LOC('<LOC mCC_toggle_info>Enter again this command to revert its effect.')
			else
				param = GetCameraShakeMult() or 1.0   # DEVRAIT TRE LA DERNIRE VALEUR SAISIE !
				aide = LOCF('<LOC cmnde_aide_05>%s is Disabled !', cmnde) .. LOC('<LOC mCC_toggle_info>Enter again this command to revert its effect.')
			end
			muteCon = true
			substLigne = string.format('cam_ShakeMult %3.2f', param )
			cmdLine = { ligne = cmnde, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		end
		
	end
	
	# RENVOI de la COMMANDE ORIGINALE INTACTE
	local tDeb, tFin = string.find( texte, ' ' )
	if not (tDeb == nil) and not (tFin == nil) then
		cmnde = string.sub( texte, 1, (tDeb-1) )
		param = tonumber(  string.sub( texte, (tDeb+1), string.len(texte) )  )
	end
	cmdLine = { ligne = texte, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
	return cmdLine
end


################################################################################


