--[[################################################################################
    # File      : /hook/lua/ui/dialogs/console.lua                                 #
    # Author    : GPG Devs / Manimal                                               #
    # Version   : 25 septembre 2008                                                #
    # Revision  : 09 novembre 2008                                                 #
    #                                                                              #
    # Summary   : Console that brings some new features                            #
    # Copyright :  2005 Gas Powered Games, Inc. All rights reserved.              #
    ################################################################################]]--
	
## NBR LIGNES ORIGINAL = 236

# NOTES :
# =======

# ==>> AJOUTER 1 GLISSIERE GAME SPEED  <<==

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# AJOUTER 1 BOUTON [List Commands] trs pratique !!!!
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# AJOUTER INFO DBIT KBPS ENTRANT ET SORTANT DU JEU !!! :S
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

local Game = import('/lua/game.lua')
local MonMod = Game.MonMod
local MyModPath = Game.MyModPath


################################################################################
# IMPORTS Console

local Bitmap = import('/lua/maui/bitmap.lua').Bitmap               # commune
local Border = import('/lua/maui/border.lua').Border               # commune
local Edit = import('/lua/maui/edit.lua').Edit                     # commune
local Group = import('/lua/maui/group.lua').Group                  # commune
local ItemList = import('/lua/maui/itemlist.lua').ItemList         # commune
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')        # commune
local UIUtil = import('/lua/ui/uiutil.lua')                        # commune
local Control = import('/lua/maui/control.lua').Control            # Console
local IntegerSlider = import('/lua/maui/slider.lua').IntegerSlider # Console
local Prefs = import('/lua/user/prefs.lua')                        # Console
local Scrollbar = import('/lua/maui/scrollbar.lua').Scrollbar      # Console
local Window = import('/lua/maui/window.lua').Window               # Console
local Checkbox = import('/lua/maui/checkbox.lua').Checkbox         # CreateUnit
local Combo = import('/lua/ui/controls/combo.lua').Combo           # CreateUnit
local RadioGroup = import('/lua/maui/mauiutil.lua').RadioGroup     # CreateUnit
local Text = import('/lua/maui/text.lua').Text                     # CreateUnit
local Tooltip = import('/lua/ui/game/tooltip.lua')


################################################################################
# VARIABLES Console

local commandDeque = {}
local maxCommandDequeSize = 10
local currentCommandDequeIndex = 0
local currentText = ""
local consoleFontName = UIUtil.fixedFont
local consoleFontSize = 12
COfontWidth = 8      # Measured from screenshots
COfontHeight = 12    # Measured from screenshots
local window = false


################################################################################
# IMPORTS Perso

local GameMain = import( MyModPath.. '/hook/lua/ui/game/gamemain.lua' )   # WILL TOGGLE NoCameraShake STATE AT GAME START.
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local ConsoleCommands = import( MyModPath..'/hook/lua/ui/dialogs/ConsoleCommands.lua' )
local mesCommandesConsole = ConsoleCommands.mesCommandesConsole
local myConTextMatches = ConsoleCommands.myConTextMatches
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local ConsolePlus = import( MyModPath..'/hook/lua/ui/dialogs/ConsolePlus.lua' )
#local BatchSaveLoad = import( MyModPath..'/hook/lua/ui/dialogs/BatchSaveLoad.lua ' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


################################################################################
# VARIABLES Perso

local dialog = false
itemBufferSize = 1000    # CHANG Buffer 300 -> 1000 # NBR REL = 434 commandes (FA v.1.5.3599) + mes commandes + autant de descriptions avec Help
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
IsFirstRun = true
myConSplash = LOCF('<LOC _myConSplash>\"%s v.%d by %s\"', MonMod.name, MonMod.version, MonMod.author)
hideMyConSplash = false
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
recupText = { }  # DUMP TEMP Console  # INFO SENSIBLE, NE PAS TOUCHER !
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local AlphaConSliderLocked = Prefs.GetFromCurrentProfile('console_alpha_locked') or false
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local batchIsLoaded = false
local monBatch = {}
local derniereEntree = ""
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
consW = 400           # scrollbar width = 38 is included in this width
consH = 300
batchW = 300
btnW = 64                    # Measures obtainued from my own pictures
toolPW = btnW + 6
menuPW = btnW + 6
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



################################################################################
################################################################################
# FONCTIONS Perso
################################################################################
################################################################################


--[[################################################################################
# Manimal's Utility: REMOVES JUNK CHARACTERS from CORRUPTED LOCALIZED STRINGS
# THIS IS A TEMPORARY SOLUTION UNTIL GPG REPAIR THE LOC FILES !
################################################################################]]--

local FilteredLOC = function ( dirtyString )
	if not dirtyString or not ( type(dirtyString) == 'string' ) then
		WARN("MANIMAL DEBUG: console.lua -> Error in FilteredLOC: dirtyString is missing or is not a string !")
		return false
	end
	
	dirtyString = LOC(dirtyString) # Get the original LOC string "as is".
	local myString = ""
	while true do
		local i, j = string.find( dirtyString, " " )
		if (i == nil) and (j == nil) then
			myString = dirtyString
			break
		end
		dirtyString = string.sub(dirtyString, 1, (i-1)) .. string.sub(dirtyString, (j+1))  # Remove the crap out of the string
	end

	return myString or false	# LUA REF does NOT tell what error could be returned by string.format
end



--[[################################################################################
# Manimal's Utility: REMOVES JUNK CHARACTERS from CORRUPTED LOCALIZED STRINGS
################################################################################
# AN ERROR CAN OCCURS WITH Prefs.GetFromCurrentProfile('console_alpha') ALONE BECAUSE IT IS SET FROM
# A MISSING FIELD WITHIN Game.Prefs, DUE TO THE LOCF ERROR BELOW THAT PREVENTS CONFIG TO UPDATE IT !!!
# ORIGINAL LINES ARE DISABLED BECAUSE LOCF RAISES A FORMAT ERROR DUE TO CRAP WITHIN LOCALIZED STRINGS
# -> local label = UIUtil.CreateText(client, LOCF("<LOC console_alpha>Alpha: %d%%", defValue), 14)
# -> label:SetText(LOCF("<LOC console_alpha>Alpha: %d%%", newValue))
# THIS IS A TEMPORARY SOLUTION UNTIL GPG REPAIR THE LOC FILES !
# -> label = UIUtil.CreateText( client, FilteredLOCF("<LOC console_alpha>Alpha: %d%%" , defValue), 14 )
# -> label:SetText( FilteredLOCF("<LOC console_alpha>Alpha: %d%%", newValue) )
################################################################################]]--

local FilteredLOCF = function ( dirtyString, value )
	if not dirtyString or not ( type(dirtyString) == 'string' ) then
		WARN("MANIMAL DEBUG: console.lua -> Error in FilteredLOCF: dirtyString is missing or is not a string !")
		return false
	end
	if not value or not ( type(value) == 'number' ) then 
		WARN("MANIMAL DEBUG: console.lua -> Error in FilteredLOCF: value is missing or is not a number !")
		return false
	end
	
	dirtyString = LOC(dirtyString) # Get the original LOC string "as is".
	local myStringF = ""
	while true do
		local i, j = string.find( dirtyString, " " )
		if (i == nil) and (j == nil) then
			myStringF = dirtyString
			break
		end
		dirtyString = string.sub(dirtyString, 1, (i-1)) .. string.sub(dirtyString, (j+1))  # Remove the crap out of the string
	end
	myStringF = string.format( myStringF, value ) # Format the string representation of the value

	return myStringF or false	# LUA REF does NOT tell what error could be returned by string.format
end



################################################################################

function InsertConCommandInQueue(text)
    table.insert(commandDeque, text)
    if table.getn(commandDeque) > maxCommandDequeSize then
        table.remove(commandDeque, 1)
    end
    currentCommandDequeIndex = table.getn(commandDeque)
end



################################################################################
################################################################################
# Manimal's Console Plus Configuration Window - features some more settings ! BD
################################################################################
################################################################################


function ConfigWindow( parent )
	#  VOIR pour TABS : lua.scd/lua/ui/dialogs/score.lua LIGNE 511
    # SetNewPage(tabControl)    #-- when a new page is selected, create the page and deal with the tab correctly
	
	if window then return end
	
	local CONSOLE_LINES = Prefs.GetFromCurrentProfile("console_size") or 5
	local CONSOLE_FADE_DELAY = Prefs.GetFromCurrentProfile("console_fade_delay") or 3
	local CONSOLE_FONT_SIZE = Prefs.GetFromCurrentProfile("console_font_size") or 12
	local CONSOLE_FONT_COLOR = Prefs.GetFromCurrentProfile("console_font_color") or "FFbadbdb"
	local CONSOLE_FONT = Prefs.GetFromCurrentProfile("console_font") or "Zeroes Three"
	
	# ==========================================================================
	# FENTRE de CONFIG
	
	local windowT = 30
	local sliderPanelH = 60
	local ncsPanelH = 40
	local echPanelH = 60 + 40 + 40 # 1 SLIDER pour Alpha Echo + 2 BOUTONS VOIR PLUS ! (5 rglages)
	local clientInHeight = sliderPanelH + ncsPanelH + echPanelH
	local clientInWidth = 160
	local margin = 5
	local fontSize = 14
	
	local windowName = FilteredLOC('<LOC console_0000>Console Config')
    window = Window(GetFrame(0), windowName, nil, nil, nil, true)
    window.Left:Set(function() return parent.Left() + 10 end)
    window.Top:Set(function() return parent.Top() + windowT end)
    window.Right:Set(function() return parent.Left() + 280 end) # SEMBLE CORRECT
    window.Bottom:Set(function() return parent.Top() + windowT + clientInHeight end)
    window.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
	Tooltip.AddButtonTooltip(window._closeBtn, 'consplus_config_close')
	
    local client = window:GetClientGroup()
	
    # New items will be part of Groups below 
	client.sliPanel = Group( client, "sliPanel" )
	sliPan = client.sliPanel
    LayoutHelpers.AtLeftTopIn( sliPan, client, margin, margin )
    sliPan.Width:Set( clientInWidth )
    sliPan.Height:Set( sliderPanelH )
	
    client.echPanel = Group( client, "echPanel" ) # servira pour rglages echo (echPanel)
	echPan = client.echPanel
    LayoutHelpers.Below( echPan, sliPan )
    echPan.Width:Set( clientInWidth )
    #echPan.Height:Set( echPanelH )
    echPan.Height:Set( 2 ) # temporaire pour mise au point ncsPanel
	
    client.ncsPanel = Group( client, "ncsPanel" )
    ncsPan = client.ncsPanel
    LayoutHelpers.Below( ncsPan, echPan )
    ncsPan.Width:Set( clientInWidth )
    ncsPan.Height:Set( ncsPanelH )
	
	# ==========================================================================
	# RGLAGE ALPHA de la CONSOLE : label + valeur courante + glissire
	
	local defValue = Prefs.GetFromCurrentProfile('console_alpha') or 1
    defValue = defValue * 100

	# LABEL
	local labelName = FilteredLOCF("<LOC console_alpha>Alpha: %d%%" , defValue)
	sliPan.AlphaConSliderLabel = UIUtil.CreateText( sliPan, labelName, fontSize )
    LayoutHelpers.AtLeftTopIn( sliPan.AlphaConSliderLabel, sliPan, margin, margin )
	
	# GLISSIRE 
    sliPan.AlphaConSlider = IntegerSlider( sliPan, false, 20, 100, 1,     # NE PAS DEPASSER 100 SINON VALEURS > 100 % !!!
			UIUtil.SkinnableFile('/slider02/slider_btn_up.dds'),
			UIUtil.SkinnableFile('/slider02/slider_btn_over.dds'),
			UIUtil.SkinnableFile('/slider02/slider_btn_down.dds'), 
            UIUtil.SkinnableFile('/dialogs/options-02/slider-back_bmp.dds') )
    LayoutHelpers.Below( sliPan.AlphaConSlider, sliPan.AlphaConSliderLabel )
	
	Tooltip.AddControlTooltip(sliPan.AlphaConSlider._background, 'consplus_config_alphaSlider')
	
	local oldAlphaConSliderThumbHandleEvent = sliPan.AlphaConSlider._thumb.HandleEvent
	sliPan.AlphaConSlider._thumb.HandleEvent = function( control, event )
		eventHandled = false 
		if AlphaConSliderLocked then
			eventHandled = true
		else
			eventHandled = oldAlphaConSliderThumbHandleEvent( control, event )
		end
		return eventHandled
    end
	
	local oldAlphaConSliderBkgndHandleEvent = sliPan.AlphaConSlider._background.HandleEvent
	sliPan.AlphaConSlider._background.HandleEvent = function( control, event )
		eventHandled = false 
		if AlphaConSliderLocked then
			eventHandled = true
		else
			eventHandled = oldAlphaConSliderBkgndHandleEvent( control, event )
		end
		return eventHandled
    end
	
	sliPan.AlphaConSlider.OnValueSet = function(self, newValue)   end
	
    sliPan.AlphaConSlider.OnValueChanged = function(self, newValue)
		newValue = MATH_IRound( newValue )      # POUR CONTROLE VALEUR => ARRONDI: keep INTEGRAL part ONLY
		parent:SetAlpha( newValue / 100, true ) # MODIFIER TRANSPARENCE DE LA FENETRE CONFIG !
		sliPan.AlphaConSliderLabel:SetText( FilteredLOCF("<LOC console_alpha>Alpha: %d%%", newValue) )
    end
	
    sliPan.AlphaConSlider:SetValue(defValue)
    
	# ==========================================================================
	# VERROU RGLAGE ALPHA de la CONSOLE [LOCK] :  case  cocher + label  
	
	# CASE  COCHER
    sliPan.AlphaConSliderLockBtn = UIUtil.CreateCheckboxStd( sliPan, '/dialogs/check-box_btn/radio' )
    LayoutHelpers.RightOf( sliPan.AlphaConSliderLockBtn, sliPan.AlphaConSlider, margin )
	LayoutHelpers.AtVerticalCenterIn( sliPan.AlphaConSliderLockBtn, sliPan )
    sliPan.AlphaConSliderLockBtn.key = 'consolealpha'
    
	Tooltip.AddCheckboxTooltip(sliPan.AlphaConSliderLockBtn, 'consplus_config_alphaSliderLock')
	
	# LABEL
	local alsLabel = "<LOC lock_asl>Lock"
    sliPan.AlphaConSliderLockBtnLabel = UIUtil.CreateText( sliPan, alsLabel, fontSize, UIUtil.bodyFont )
    LayoutHelpers.Above( sliPan.AlphaConSliderLockBtnLabel, sliPan.AlphaConSliderLockBtn )
	
    sliPan.AlphaConSliderLockBtn.OnCheck = function(self, checked)
		if self:IsChecked() then                                         # DSACTIVER GLISSIRE TRANSPARENCE
			sliPan.AlphaConSlider:SetAlpha( 0.5, true )                  # VISIBILIT GLISSIRE = RDUITE
			AlphaConSliderLocked = true                                
		else                                                             # ACTIVER GLISSIRE TRANSPARENCE
			sliPan.AlphaConSlider:SetAlpha( 1, true )                    # VISIBILIT GLISSIRE = NORMALE
			AlphaConSliderLocked = false                               
		end
		Prefs.SetToCurrentProfile('console_alpha_locked', AlphaConSliderLocked)
    end
	if AlphaConSliderLocked then
		sliPan.AlphaConSliderLockBtn:SetCheck(true)
	else
		sliPan.AlphaConSliderLockBtn:SetCheck(false)
	end
	
	# ==========================================================================
	# BOUTON [NO CAM SHAKE] : case  cocher + label

	local ncsLabel = "<LOC lock_ncs>No Camera Shake"
    
	# CASE  COCHER
    ncsPan.noCamShakeBtn = UIUtil.CreateCheckboxStd( ncsPan, '/dialogs/check-box_btn/radio' )
    LayoutHelpers.AtLeftTopIn( ncsPan.noCamShakeBtn, ncsPan, margin, margin )
    ncsPan.noCamShakeBtn.key = 'camshakeconf'
	
	Tooltip.AddCheckboxTooltip(ncsPan.noCamShakeBtn, 'consplus_config_noCamShake')
    
	# LABEL
    ncsPan.noCamShakeBtnLabel = UIUtil.CreateText( ncsPan, ncsLabel, fontSize, UIUtil.bodyFont )
    LayoutHelpers.RightOf( ncsPan.noCamShakeBtnLabel, ncsPan.noCamShakeBtn )
    LayoutHelpers.AtVerticalCenterIn( ncsPan.noCamShakeBtnLabel, ncsPan )
    
	local oldNoCamShakeBtnOnClick = ncsPan.noCamShakeBtn.OnClick
    ncsPan.noCamShakeBtn.OnClick = function( self, modifiers )
		oldNoCamShakeBtnOnClick( self, modifiers )
		ConsolePlus.ToggleCameraShake()
    end
		
	if GameMain.NoCameraShake then
		ncsPan.noCamShakeBtn:SetCheck(true)
	else
		ncsPan.noCamShakeBtn:SetCheck(false)
	end
	
	# ==========================================================================
	# FERMETURE FENTRE CONFIG
	# ========================
    window.OnClose = function(self)
        Prefs.SetToCurrentProfile('console_alpha', sliPan.AlphaConSlider:GetValue()/100)
        window:Destroy()
        window = false
    end
end




################################################################################
################################################################################
# #    C O N S O L E   P L U S    b y    M A N I M A L
################################################################################
################################################################################


function CreateDialog()
	
    local mainFrame = GetFrame(0)

	# ==========================================================================
	# CRER la FENTRE de la CONSOLE
	# ==============================
	local win_top_bar = 30             # Measures obtainued from window.lua 
	local win_bot_bar = 10             # Measures obtainued from screenshots
	local editH = consoleFontSize + 4  # Measures obtainued from screenshots
	local margin = 5
	local spacer = 10
	
	local cpl_win_loc = Prefs.GetFromCurrentProfile( 'console_window' )
    local cpl_Top = cpl_win_loc.top or 10
    local cpl_Left = cpl_win_loc.left or 10 
    local cpl_H = win_top_bar + consH + spacer + editH + spacer + win_bot_bar # Heights from Top to Bottom
    local cpl_W = spacer + consW + spacer + toolPW + spacer + batchW + spacer + menuPW
    local cpl_Bottom = cpl_Top + cpl_H
    local cpl_Right  = cpl_Left + cpl_W
	
    local location = { Top = cpl_Top, Left = cpl_Left, Bottom = cpl_Bottom , Right = cpl_Right }
	local windowName = FilteredLOC('<LOC _Console>Console')
	windowName = windowName .. ' Plus'
    dialog = Window( mainFrame, windowName, nil, nil, true, false, false, 'console_window', location ) # RESIZABLE 
    #dialog = Window( mainFrame, windowName, nil, nil, true, true, false, 'console_window', location ) # SIZE LOCKED
    dialog.Depth:Set(UIUtil.consoleDepth)
    dialog:SetMinimumResize( cpl_W, cpl_H )
	#dialog:SetSizeLock(true)          # Fonctionnel avec mon patch aWindowLua.scd !
	#if dialog:IsSizeLocked()  then    # Fonctionnel avec mon patch aWindowLua.scd !
	#	LOG(" IS SIZE LOCKED = TRUE")
	#end
	
	Tooltip.AddButtonTooltip(dialog._configBtn, 'consplus_config')
	Tooltip.AddButtonTooltip(dialog._closeBtn, 'consplus_close')
	
    local clientGrp = dialog:GetClientGroup()
	
	# PANELS DEFINITION	
    clientGrp.conPanel = Group( clientGrp, "conPanel" )
	conPan = clientGrp.conPanel
    LayoutHelpers.AtLeftTopIn( conPan, clientGrp, margin, margin )
    conPan.Width:Set( consW )
    conPan.Height:Set( consH )
	
	clientGrp.toolPanel = Group( clientGrp, "toolPanel" )
	toolPan = clientGrp.toolPanel
    LayoutHelpers.RightOf( toolPan, conPan )
    toolPan.Width:Set( toolPW )
    toolPan.Height:Set( consH )
	
	clientGrp.batPanel = Group( clientGrp, "batPanel" )
	batPan = clientGrp.batPanel
    LayoutHelpers.RightOf( batPan, toolPan )
    batPan.Width:Set( batchW )
    batPan.Height:Set( consH )
	
	clientGrp.menuPanel = Group( clientGrp, "menuPanel" )
	menuPan = clientGrp.menuPanel
    LayoutHelpers.RightOf( menuPan, batPan )
    menuPan.Width:Set( menuPW )
    menuPan.Height:Set( consH )
	
	# ==========================================================================
	# CONSOLE PANEL
	
	# BOITE de SAISIE CONSOLE
    conPan.editCon = Edit( conPan )
    conPan.editCon.Left:Set(function() return conPan.Left() + spacer end)
    conPan.editCon.Right:Set(function() return conPan.Right() - 38 end)
    conPan.editCon.Bottom:Set(function() return conPan.Bottom() - spacer end)
    conPan.editCon:SetForegroundColor(UIUtil.consoleFGColor())
    conPan.editCon:SetBackgroundColor('ff333333')
    conPan.editCon:SetHighlightForegroundColor("black")
    conPan.editCon:SetHighlightBackgroundColor(UIUtil.consoleTextBGColor())
    conPan.editCon:SetFont(consoleFontName, consoleFontSize)
    conPan.editCon.Height:Set(function() return math.floor(conPan.editCon:GetFontHeight()) end)
	
	# AFFICHAGE bis de la CONSOLE
	conPan.consoleOutput = ItemList( conPan )
    LayoutHelpers.Above( conPan.consoleOutput, conPan.editCon, spacer )
    conPan.consoleOutput.Top:Set(function() return conPan.Top() + margin end)
    conPan.consoleOutput.Right:Set( conPan.editCon.Right )
    conPan.consoleOutput:SetColors(UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor(), UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor()) -- we don't really want selection here so don't differentiate colors
    conPan.consoleOutput:SetFont(consoleFontName, consoleFontSize)
	
	# ASCENCEUR pour AFFICHAGE bis de la CONSOLE
    UIUtil.CreateVertScrollbarFor( conPan.consoleOutput )
	
	# ==========================================================================
	# TOOLS PANEL
	
	# BOUTON ADD CMDE !
    toolPan.addBtn = UIUtil.CreateButtonStd( toolPan, '/widgets/tiny', "+", 18 )
    LayoutHelpers.AtLeftTopIn( toolPan.addBtn, toolPan, margin, margin )
	Tooltip.AddButtonTooltip( toolPan.addBtn, 'consplus_add' )
	
	# BOUTON DEL CMDE !
    toolPan.delBtn = UIUtil.CreateButtonStd( toolPan, '/widgets/tiny', "-", 14 )
    LayoutHelpers.Below( toolPan.delBtn, toolPan.addBtn, margin )
	Tooltip.AddButtonTooltip( toolPan.delBtn, 'consplus_del' )
	
	# BOUTON CLEAR EDIT !
    toolPan.clearBtn = UIUtil.CreateButtonStd( toolPan, '/widgets/tiny', "x", 14 )
    LayoutHelpers.Below( toolPan.clearBtn, toolPan.delBtn, margin )
	Tooltip.AddButtonTooltip( toolPan.clearBtn, 'consplus_clear' )
	
	# BOUTON AIDE !
    toolPan.aideBtn = UIUtil.CreateButtonStd( toolPan, '/widgets/tiny', "?", 14 )
    LayoutHelpers.Below( toolPan.aideBtn, toolPan.clearBtn, margin ) 
	Tooltip.AddButtonTooltip( toolPan.aideBtn, 'consplus_aide' )
	
	
	# ==========================================================================
	# BATCHER PANEL
	
	# BOITE de SAISIE BATCHER
    batPan.editBat = Edit( batPan )
    batPan.editBat.Left:Set(function() return batPan.Left() + spacer end)
    batPan.editBat.Right:Set(function() return batPan.Right() - 38 end)
    batPan.editBat.Bottom:Set(function() return batPan.Bottom() - spacer end)
    batPan.editBat:SetForegroundColor(UIUtil.consoleFGColor())
    batPan.editBat:SetBackgroundColor('ff333333')
    batPan.editBat:SetHighlightForegroundColor("black")
    batPan.editBat:SetHighlightBackgroundColor(UIUtil.consoleTextBGColor())
    batPan.editBat:SetFont(consoleFontName, consoleFontSize)
    batPan.editBat.Height:Set(function() return math.floor(batPan.editBat:GetFontHeight()) end)
	
	# AFFICHAGE du BATCHER
	batPan.batcherOutput = ItemList( batPan )
    LayoutHelpers.Above( batPan.batcherOutput, batPan.editBat, spacer )
    batPan.batcherOutput.Top:Set(function() return batPan.Top() + margin end)
    batPan.batcherOutput.Right:Set( batPan.editBat.Right )
    batPan.batcherOutput:SetColors(UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor(), UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor()) -- we don't really want selection here so don't differentiate colors
    batPan.batcherOutput:SetFont(consoleFontName, consoleFontSize)
	
	# ASCENCEUR pour AFFICHAGE bis de la CONSOLE
    UIUtil.CreateVertScrollbarFor( batPan.batcherOutput )
	
	
	# ==========================================================================
	# MENU PANEL
	
	# BOUTON NOUVEAU BATCH !
    menuPan.newbBtn = UIUtil.CreateButtonStd( menuPan, '/widgets/tiny', "<LOC _newbBtn>New", 10 )
    LayoutHelpers.AtLeftTopIn( menuPan.newbBtn, menuPan, margin, margin )
	Tooltip.AddButtonTooltip( menuPan.newbBtn, 'consplus_newb' )
	
	# BOUTON CHARGER BATCH !
    menuPan.loadBtn = UIUtil.CreateButtonStd( menuPan, '/widgets/tiny', "<LOC _loadBtn>Load", 10 )
    LayoutHelpers.Below( menuPan.loadBtn, menuPan.newbBtn, margin ) #  DROITE DE editBat, EN DESSOUS du Bouton New
	Tooltip.AddButtonTooltip( menuPan.loadBtn, 'consplus_load' )
	
	# BOUTON SAUVEGARDER BATCH !
    menuPan.saveBtn = UIUtil.CreateButtonStd( menuPan, '/widgets/tiny', "<LOC _saveBtn>Save", 10 )
    LayoutHelpers.Below( menuPan.saveBtn, menuPan.loadBtn, margin ) #  DROITE DE editBat, EN DESSOUS du Bouton Load
	Tooltip.AddButtonTooltip( menuPan.saveBtn, 'consplus_save' )
	
	# BOUTON EXECUTER BATCH !
    menuPan.runBtn = UIUtil.CreateButtonStd( menuPan, '/widgets/tiny', "<LOC _runBtn>Run", 10 )
    LayoutHelpers.Below( menuPan.runBtn, menuPan.saveBtn, margin ) #  DROITE DE editBat, EN DESSOUS du Bouton Save
	Tooltip.AddButtonTooltip( menuPan.runBtn, 'consplus_run' )
	
	
	# ==========================================================================
	
	function AddMuteOutputHandler()
		-- set up output control to recieve console spew
		return AddConsoleOutputReciever( function(text)
			table.insert(ConsoleCommands.recupData, text)    # BIEN GRER LE TAMPON recupText SINON GARE AU DEBORDEMENT ! :[
		end)
	end
	
	
	function RemoveMuteOutputHandler()
		if muteOutputHandler then
			RemoveConsoleOutputReciever( muteOutputHandler )
		end
	end
	
	# ==========================================================================
	
	muteOutputHandler = AddMuteOutputHandler()	
	
	ConsoleCommands.GetCommandsListFromConsole()
	ConsoleCommands.CreateDetailedConsoleCommandsList()
	
	RemoveMuteOutputHandler()

	# ==========================================================================
	
	function AddOutputHandler()
		-- set up output control to recieve console spew
		return AddConsoleOutputReciever( function(text)
			table.insert(recupText, text)    # BIEN GRER LE TAMPON recupText SINON GARE AU DEBORDEMENT !
			
			conPan.consoleOutput:AddItem(text)
			local itemCount = conPan.consoleOutput:GetItemCount()
			
			if ( itemCount > itemBufferSize ) then  -- number of items should be = number of commands (enter Help command as a good example)
				conPan.consoleOutput:DeleteItem(0)
			end
			conPan.consoleOutput:SetSelection(itemCount - 1)
			conPan.consoleOutput:ScrollToBottom()
		end)
	end
	
	outputHandler = AddOutputHandler()	
	
	function RemoveOutputHandler()
		if outputHandler then
			RemoveConsoleOutputReciever( outputHandler )
		end
	end
	
	# ==========================================================================
	# Effacer Affichage de la CONSOLE 
	
	function ClearConsoleDisplay()
		if conPan.consoleOutput then
			conPan.consoleOutput:DeleteAllItems()
			conPan.consoleOutput:Empty()
			ConExecute( 'con_echo'..' '..myConSplash )
			hideMyConSplash = true
		end
	end
	
	# ==========================================================================
		
    dialog.OnConfigClick = function(self)
        ConfigWindow(dialog)
    end
    -- if this gets destroyed we need to unregister and destroy the output handler
    dialog.OnDestroy = function(self)
		RemoveConsoleOutputReciever(outputHandler)
    end
	
    -- HANDLE EDIT CONTROL
    local conFuncsList = false
    local raiseConFuncList = true
	
    conPan.editCon.OnTextChanged = function(self, newText, oldText)
        if raiseConFuncList then
            if conFuncsList then
                conFuncsList:Destroy()
                conFuncsList = false
            end
            local conMatches = ConTextMatches(newText)
			local matches = myConTextMatches( conMatches, newText )   ## Fusion de ma Liste de Commandes
            local numMatches = table.getn(matches)
            if (numMatches > 0) then
                conFuncsList = ItemList(conPan.consoleOutput)  ### <<<====== INTERCEPTER LA CONSOLE  ICI ?!?
                conFuncsList:SetFont(consoleFontName, consoleFontSize)
                LayoutHelpers.Above(conFuncsList, conPan.editCon)
                conFuncsList.Right:Set(function() return conPan.editCon.Right() - 32 end)
                conFuncsList.Height:Set(function()
                    return math.min(conPan.consoleOutput.Height(), conFuncsList:GetRowHeight() * numMatches)
                end)
				
                for i,v in matches do
					conFuncsList:AddItem(v)
                end
				
                if conFuncsList:NeedsScrollBar() then
                    UIUtil.CreateVertScrollbarFor(conFuncsList)
                end
                
                conFuncsList:SetSelection(conFuncsList:GetItemCount() - 1)
                conFuncsList:ScrollToBottom()
				
                conFuncsList.OnDoubleClick = function(self, row)
                    conPan.editCon:SetText(conFuncsList:GetItem(row))
                    conPan.editCon:AcquireFocus()
                end
            end
        end
    end
	
	############################################################################
	
    ExecuterCommande = function( text )    # COMMANDE DJ EXECUTE QUAND OnEnterPressed EST SIGNAL !
		
		local cmdLine = ConsolePlus.Interpreter( text )	# GRER LE FILTRAGE DU TEXTE SINON GARE AUX FUITES ! :P
		if not cmdLine or (cmdLine == nil) then
			WARN(' MANIMAL DEBUG:  console.lua  -> ExecuterCommande has no cmdLine to work with ! ')
		end
		
		if (string.len(cmdLine.ligne) > 0) then
			if (string.lower(cmdLine.ligne) == string.lower('CON_ClearDisplay') ) then
				#  FAIRE: TROUVER AUTRE SOLUTION (appel depuis Interpreter ?) # NE SE COMPORTAIT PAS COMME PRVU HORS DE CE BLOC
				ClearConsoleDisplay()    # CLEAR CONSOLE SCREEN
				InsertConCommandInQueue(cmdLine.ligne)
			end
			if cmdLine.muteCon then    # MODE <<SILENCIEUX>>
				# SEMBLE TRE INOPERANT -> #ConsoleEcho.showEchoOnConsole = false  # Fixer TAT Console Echo
				
				RemoveOutputHandler()                            # FERMER RECEPTEUR <!>
				if (string.len(cmdLine.substLigne) == 0) then
					ConExecuteSave( cmdLine.ligne )
				else
					ConExecuteSave( cmdLine.substLigne )
					InsertConCommandInQueue(cmdLine.ligne)
				end
				outputHandler = AddOutputHandler()               # OUVRIR RECEPTEUR <!>
				
				# SEMBLE TRE INOPERANT -> #ConsoleEcho.showEchoOnConsole = true  # Fixer TAT Console Echo
			else    # MODE <<NORMAL>>
				if (string.len(cmdLine.substLigne) == 0) then
					ConExecuteSave(cmdLine.ligne)
					InsertConCommandInQueue(cmdLine.ligne)
				else
					ConExecuteSave( cmdLine.substLigne )
					InsertConCommandInQueue(cmdLine.ligne)
				end
			end
		end
		if string.len(cmdLine.aide) > 0 then
			ConExecute(('con_echo'..' '..cmdLine.aide))
		end
		cmdLine = {}
    end
	
	############################################################################
	
	
    conPan.editCon.OnEnterPressed = function(self, text)    # COMMANDE DJ EXECUTE QUAND OnEnterPressed EST SIGNAL !
		ExecuterCommande( text ) 
    end
	
	
    conPan.editCon.OnNonTextKeyPressed = function(self, keycode)
        local function ChangeConFuncSelection(direction)
            local selection = math.max(math.min(conFuncsList:GetSelection() + direction, conFuncsList:GetItemCount() - 1), 0)
            conFuncsList:SetSelection(selection)
            raiseConFuncList = false
            conPan.editCon:SetText(conFuncsList:GetItem(selection))
            raiseConFuncList = true
        end
		
		if keycode == UIUtil.VK_UP then
            if conFuncsList then
                ChangeConFuncSelection(-1)
            else
                -- store off the current text if this is the first press
                local commandDequeSize = table.getn(commandDeque)
                if commandDequeSize > 0 then
                    if currentCommandDequeIndex == commandDequeSize then currentText = conPan.editCon:GetText() end
                    conPan.editCon:SetText(commandDeque[currentCommandDequeIndex])
                    currentCommandDequeIndex = currentCommandDequeIndex - 1
                    if currentCommandDequeIndex <= 0 then currentCommandDequeIndex = 1 end
                end
            end
        elseif keycode == UIUtil.VK_DOWN then
            if conFuncsList then
                ChangeConFuncSelection(1)
            else
                currentCommandDequeIndex = currentCommandDequeIndex + 1
                if currentCommandDequeIndex > table.getn(commandDeque) then
                    currentCommandDequeIndex = table.getn(commandDeque)
                    conPan.editCon:SetText(currentText)
                else
                    conPan.editCon:SetText(commandDeque[currentCommandDequeIndex])
                end
            end
        end
    end
	
    conPan.editCon.OnCharPressed = function(self, charcode)
        -- close console on tilde key (apostrophe, or ascii 96)
        if charcode == 96 then
            conPan.editCon:AbandonKeyboardFocus()
            dialog:Hide()
            return true
        elseif charcode == UIUtil.VK_TAB then
            if conFuncsList then
                conPan.editCon:SetText(conFuncsList:GetItem(conFuncsList:GetSelection()))
                return true
            else
                return false
            end
        else
            return false
        end
    end
	
	# ==========================================================================
	
	
    toolPan.addBtn.OnClick = function(button)
		if conFuncsList then 
			local itemCount = conFuncsList:GetItemCount() - 1
			if (itemCount > 0) then
				local currentText = conFuncsList:GetItem(conFuncsList:GetSelection()) # CLONER la SELECTION de CONSOLE
				batPan.editBat:SetText( currentText )
				derniereEntree = currentText
			end
		end
    end
	
    toolPan.delBtn.OnClick = function(button)
		local itemCount = batPan.batcherOutput:GetItemCount()
		if (itemCount > 0) then
			batPan.batcherOutput:SetSelection(itemCount - 1) # -1 ici sinon il restera 1 item non effacable
			batPan.batcherOutput:DeleteItem(0)
			itemCount = batPan.batcherOutput:GetItemCount() - 1
			if (itemCount > 0) then
				batPan.batcherOutput:SetSelection(itemCount)
			end
			batPan.batcherOutput:ScrollToBottom()
			local currentText = batPan.batcherOutput:GetItem(batPan.batcherOutput:GetSelection()) # derniere SELECTION de BATCHER
			derniereEntree = currentText
		end
	end
	
    toolPan.clearBtn.OnClick = function(button)
		derniereEntree = ""
		batPan.editBat:SetText( derniereEntree ) # EFFACER le TEXTE de la BOITE de SAISIE
	end
	
    toolPan.aideBtn.OnClick = function(button)
		ConsolePlus.DisplayConPlusHelpWindow()
    end
	
	# ==========================================================================
	
	
    batPan.editBat.OnEnterPressed = function(self, text)    # COMMANDE DJ EXECUTE QUAND OnEnterPressed EST SIGNAL !
		batPan.batcherOutput:AddItem(text)
		local itemCount = batPan.batcherOutput:GetItemCount() - 1
		
		if ( itemCount > itemBufferSize ) then  -- number of items should be = maximum number of commands of the batch file
			batPan.batcherOutput:DeleteItem(0)
		else
			table.insert( monBatch, text )
		end
		batPan.batcherOutput:SetSelection(itemCount)
		batPan.batcherOutput:ScrollToBottom()
	end
	
    batPan.editBat.OnNonTextKeyPressed = function(self, keycode)
        local function ChangeBatFuncSelection(direction)
            local selection = math.max(math.min(batPan.batcherOutput:GetSelection() + direction, batPan.batcherOutput:GetItemCount() - 1), 0)
            batPan.batcherOutput:SetSelection(selection)
            batPan.editBat:SetText(batPan.batcherOutput:GetItem(selection))
        end
		
		local itemCount = batPan.batcherOutput:GetItemCount() - 1
		if keycode == UIUtil.VK_UP then
            if ( itemCount > 0 ) then
                ChangeBatFuncSelection(-1)
            end
        elseif keycode == UIUtil.VK_DOWN then
            if ( itemCount > 0 ) then
                ChangeBatFuncSelection(1)
            end
        end
		
    end
	
    batPan.editBat.OnCharPressed = function(self, charcode)
        -- close console on tilde key (apostrophe, or ascii 96)
        if charcode == 96 then
            batPan.editCon:AbandonKeyboardFocus()
            dialog:Hide()
            return true
        elseif charcode == UIUtil.VK_TAB then
            if batPan.batcherOutput then
                batPan.editBat:SetText(batPan.batcherOutput:GetItem(batPan.batcherOutput:GetSelection()))
                return true
            else
                return false
            end
        else
            return false
        end
    end
	
	# ==========================================================================
	
	
    menuPan.newbBtn.OnClick = function(button)
		derniereEntree = ""
		monBatch = nil
		monBatch = { }
		batPan.batcherOutput:DeleteAllItems()
		batPan.batcherOutput:Empty()
		batchIsLoaded = false
    end
	
    menuPan.loadBtn.OnClick = function(button)
		batchIsLoaded = false
		derniereEntree = ""
		# A BATCH IS NOT MANDATORY, PLAYER COULD WANT TO GET AN EMPTY BATCH AT GAME START !
		# AN EMPTY BATCH WOULD RESET THE BATCH DISPLAY IN CONSOLE BY THE WAY, SO KEEP IT LIKE THAT.
		monBatch = nil  
		monBatch = { }
		batPan.batcherOutput:DeleteAllItems()
		batPan.batcherOutput:Empty()
		# CHARGER Batch  partir du Profil
		monBatch = Prefs.GetFromCurrentProfile( 'console_command_batch' ) or false
		if monBatch and (table.getn(monBatch) > 0) then
			for i, cmnde in monBatch do
				batPan.batcherOutput:AddItem(cmnde)
				local itemCount = batPan.batcherOutput:GetItemCount() - 1
				if ( itemCount > itemBufferSize ) then  -- number of items should be = maximum number of commands of the batch file
					batPan.batcherOutput:DeleteItem(0)
				end
				batPan.batcherOutput:SetSelection(itemCount)
				batPan.batcherOutput:ScrollToBottom()
				derniereEntree = cmnde
			end
			batchIsLoaded = true  #  SIGNALER SI BATCH VIDE ???
			local commande = 'Echo '..LOC('<LOC batch_loaded>Batch is Loaded !')
			ExecuterCommande( commande )
		end
    end
	
	if not batchIsLoaded then
		menuPan.loadBtn.OnClick()
    end
	
    menuPan.saveBtn.OnClick = function(button)
		# A BATCH IS NOT MANDATORY, PLAYER COULD WANT TO GET AN EMPTY BATCH AT GAME START ! 
		# AN EMPTY BATCH WOULD RESET THE BATCH IN PROFILE BY THE WAY, SO KEEP IT LIKE THAT.
		# SAUVER Batch dans le Profil
		Prefs.SetToCurrentProfile( 'console_command_batch', monBatch )
		local commande = 'Echo '..LOC('<LOC batch_saved>Batch is Saved !')
		ExecuterCommande( commande )
	end
	
    menuPan.runBtn.OnClick = function(button)
		if batchIsLoaded then
			if monBatch and (table.getn(monBatch) > 0) then
				for ligne, commande in monBatch do
					LOG('MANIMAL DEBUG:  console.lua  -> RUN : Current Command = '..(commande or "PROBLEME"))
					if (type(commande) == 'string') and (string.len(commande) > 0) then
						# SKIP LINES THAT ARE COMMENTED OUT ! #  FAIRE: FILTRER INTGRALEMENT la ligne
						if ( string.sub( commande, 1, 1 ) ~= '#') or ( string.sub( commande, 1, 2 ) ~= '--') then 
							ExecuterCommande( commande )
						end
					else
						WARN('MANIMAL DEBUG: console.lua  -> Error: Attempt to use '..tostring(type(commande))..' as a console command at line '..tostring(ligne)..' (a string was expected). Skipping Erroneous Command Line...')
					end
				end
				local commande = 'Echo '..LOC('<LOC _done>done !')
				ExecuterCommande( commande )
			end
		end
    end
	
	# ==========================================================================
	
	
    -- override Show behavior to acquire keyboard focus
    dialog.Show = function(self)
		if not hideMyConSplash then
			ConExecute( 'con_echo'..' '..myConSplash )
			hideMyConSplash = true
		end
        conPan.editCon:AcquireFocus()
        Control.Show(self)
    end
	
    dialog.Hide = function(self)
        if window then
            window:Destroy()
            window = false
        end
        Control.Hide(self)
    end
	
    dialog.OnClose = function(self)
        self:Hide()
    end
	
    local tempalpha = Prefs.GetFromCurrentProfile('console_alpha') or 1
    dialog:SetAlpha(tempalpha, true)
	
    return dialog
end



################################################################################

