--[[################################################################################
    # File      : /hook/lua/modules/ui/help/tooltips.lua                           #
    # Author(s) : Ted Snook + Manimal                                              #
    # Version   : 07 novembre 2008                                                 #
    # Revision  : 09 novembre 2008                                                 #
    #                                                                              #
    # Summary   : Strings and images for the tooltips System                       #
    # Copyright :  2006 Gas Powered Games, Inc. All rights reserved.              #
    ################################################################################]]--


myTooltips = {
    #***************************************
    #** Console Plus Configuration Strings
    #***************************************
    consplus_config_close = {
        title = "<LOC tooltipuiCP023>Close Console Plus Config",
        description = "<LOC tooltipuiCP024>Click here to close the Console Plus Configuration window.",
    },
	
    consplus_config_alphaSlider = {
        title = "<LOC tooltipuiCP025>Console's Alpha setting",
        description = "<LOC tooltipuiCP026>Click and Drag this slider to modify the Console's Alpha setting.",
    },
    consplus_config_alphaSliderT = {
        title = "<LOC tooltipuiCP027>Console's Alpha setting",
        description = "<LOC tooltipuiCP028>Click here to modify the Console's Alpha setting.",
    },
    consplus_config_alphaSliderLock = {
        title = "<LOC tooltipuiCP029>Console's Alpha setting Locker",
        description = "<LOC tooltipuiCP030>Click here to Lock the slider so that prevents possible changes of the Console's Alpha setting.",
    },
	
    consplus_config_noCamShake = {
        title = "<LOC tooltipuiCP031>No Camera Shake",
        description = "<LOC tooltipuiCP032>Click here to prevent the camera from shaking during explosions in games.",
    },
	
	
    #**************************
    #** Console Plus Strings 
    #**************************
    consplus_config = {
        title = "<LOC tooltipuiCP001>Configure Console Plus",
        description = "<LOC tooltipuiCP002>Click here to configure various console options.",
    },
    consplus_close = {
        title = "<LOC tooltipuiCP003>Close Console Plus",
        description = "<LOC tooltipuiCP004>Click here to close the Console Plus window.",
    },
	
    consplus_add = {
        title = "<LOC tooltipuiCP005>Add Command",
        description = "<LOC tooltipuiCP006>Click here to Add the current selected Command to the Batch.",
    },
    consplus_del = {
        title = "<LOC tooltipuiCP007>Delete Command",
        description = "<LOC tooltipuiCP008>Click here to Remove the current selected Command from the Batch.",
    },
    consplus_clear = {
        title = "<LOC tooltipuiCP009>Clear Command",
        description = "<LOC tooltipuiCP010>Click here to Clear the Batch Edit box.",
    },
    consplus_aide = {
        title = "<LOC tooltipuiCP011>Help",
        description = "<LOC tooltipuiCP012>Click here to get summarized Help about Manimal's Batch Editor.",
    },
    consplus_newb = {
        title = "<LOC tooltipuiCP013>New Batch",
        description = "<LOC tooltipuiCP014>Click here to start over a new Batch.",
    },
    consplus_load = {
        title = "<LOC tooltipuiCP015>(re)Load Batch",
        description = "<LOC tooltipuiCP016>Click here to Reload the latest saved Batch.",
    },
    consplus_save = {
        title = "<LOC tooltipuiCP017>Save Batch",
        description = "<LOC tooltipuiCP018>Click here to Save the current displayed Batch.",
    },
    consplus_run = {
        title = "<LOC tooltipuiCP019>Run Batch",
        description = "<LOC tooltipuiCP020>Click here to Execute the Commands from the current displayed Batch.",
    },

    consplus_help_close = {
        title = "<LOC tooltipuiCP021>Close Help",
        description = "<LOC tooltipuiCP022>Click here to close the Console Plus Help window.",
    },
	
}

# Note  Bnets: I merged Tooltips this way in order to prevent losing original stuff
Tooltips = table.merged( myTooltips, Tooltips )
